KParts::Plugin class Reference (kparts Library)

| # kparts Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KParts::Plugin Class Reference

A plugin is the way to add actions to an existing KParts application, or to a Part. More...

`#include <plugin.h>`

Inheritance diagram for KParts::Plugin:

[legend]
Collaboration diagram for KParts::Plugin:

[legend]
List of all members.

## Public Member Functions
| Plugin (QObject *parent=0, const char *name=0)
| Construct a new KParts plugin.
virtual | ~Plugin ()
| Destructor.
virtual QString | xmlFile () const
| Reimplemented for internal reasons.
virtual QString | localXMLFile () const
| Reimplemented for internal reasons.
## Static Public Member Functions
void | loadPlugins (QObject *parent, const KInstance *instance)
| Load the plugin libraries from the directories appropriate to `instance` and make the Plugin objects children of `parent`.
void | loadPlugins (QObject *parent, const QValueList< PluginInfo > &pluginInfos)
| Load the plugin libraries specified by the list `docs` and make the Plugin objects children of `parent` .
void | loadPlugins (QObject *parent, const QValueList< PluginInfo > &pluginInfos, const KInstance *instance)
| Load the plugin libraries specified by the list `pluginInfos`, make the Plugin objects children of `parent`, and use the given `instance`.
void | loadPlugins (QObject *parent, KXMLGUIClient *parentGUIClient, KInstance *instance, bool enableNewPluginsByDefault=true)
| Load the plugin libraries for the given `instance`, make the Plugin objects children of `parent`, and insert the plugin as a child GUI client of `parentGUIClient`.
QPtrList< Plugin > | pluginObjects (QObject *parent)
| Returns a list of plugin objects loaded for `parent`.
## Protected Member Functions
virtual void | setInstance (KInstance *instance)
## Static Protected Member Functions
QValueList< Plugin::PluginInfo > | pluginInfos (const KInstance *instance)
| Look for plugins in the `instance's` "data" directory (+"/kpartplugins").
Plugin * | loadPlugin (QObject *parent, const char *libname)

## Detailed Description

A plugin is the way to add actions to an existing KParts application, or to a Part.

The XML of those plugins looks exactly like of the shell or parts, with one small difference: The document tag should have an additional attribute, named "library", and contain the name of the library implementing the plugin.

If you want this plugin to be used by a part, you need to install the rc file under the directory "data" (KDEDIR/share/apps usually)+"/instancename/kpartplugins/" where instancename is the name of the part's instance.

Definition at line 46 of file plugin.h.

## Constructor & Destructor Documentation

KParts::Plugin::Plugin | ( | QObject * | parent = 0,
|  | const char * | name = 0
| ) |

| Construct a new KParts plugin.

virtual KParts::Plugin::~Plugin | ( |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

virtual QString KParts::Plugin::xmlFile | ( |  | ) | const`[virtual]`

| Reimplemented for internal reasons. Reimplemented from KXMLGUIClient.

virtual QString KParts::Plugin::localXMLFile | ( |  | ) | const`[virtual]`

| Reimplemented for internal reasons. Reimplemented from KXMLGUIClient.

void KParts::Plugin::loadPlugins | ( | QObject * | parent,
|  | const KInstance * | instance
| ) | `[static]`

| Load the plugin libraries from the directories appropriate to `instance` and make the Plugin objects children of `parent`. It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void KParts::Plugin::loadPlugins | ( | QObject * | parent,
|  | const QValueList< PluginInfo > & | pluginInfos
| ) | `[static]`

| Load the plugin libraries specified by the list `docs` and make the Plugin objects children of `parent` . It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void KParts::Plugin::loadPlugins | ( | QObject * | parent,
|  | const QValueList< PluginInfo > & | pluginInfos,
|  | const KInstance * | instance
| ) | `[static]`

| Load the plugin libraries specified by the list `pluginInfos`, make the Plugin objects children of `parent`, and use the given `instance`. It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void KParts::Plugin::loadPlugins | ( | QObject * | parent,
|  | KXMLGUIClient * | parentGUIClient,
|  | KInstance * | instance,
|  | bool | enableNewPluginsByDefault = true
| ) | `[static]`

| Load the plugin libraries for the given `instance`, make the Plugin objects children of `parent`, and insert the plugin as a child GUI client of `parentGUIClient`. This method uses the KConfig object of the given instance, to find out which plugins are enabled and which are disabled. What happens by default (i.e. for new plugins that are not in that config file) is controlled by `enableNewPluginsByDefault`. If a disabled plugin is already loaded it will be removed from the GUI factory and deleted. This method is automatically called by KParts::Plugin and by KParts::MainWindow.

QPtrList<Plugin> KParts::Plugin::pluginObjects | ( | QObject * | parent | ) | `[static]`

| Returns a list of plugin objects loaded for `parent`. This functions basically calls the queryList method of QObject to retrieve the list of child objects inheriting KParts::Plugin .

QValueList<Plugin::PluginInfo> KParts::Plugin::pluginInfos | ( | const KInstance * | instance | ) | `[static, protected]`

| Look for plugins in the `instance's` "data" directory (+"/kpartplugins"). Returns: A list of QDomDocument s, containing the parsed xml documents returned by plugins.

The documentation for this class was generated from the following file:

- plugin.h

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:27:13 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001